'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('../../_virtual/_tslib.cjs');
var runtime = require('../runtime.cjs');
require('../models/AccessOutcomeEnum.cjs');
require('../models/ExchangeKeyEnum.cjs');
require('../models/AttestationConveyancePreference.cjs');
require('../models/AuthModeEnum.cjs');
require('../models/AuthStorageEnum.cjs');
require('../models/AuthenticatorAttachment.cjs');
require('../models/ResidentKeyRequirement.cjs');
require('../models/UserVerificationRequirement.cjs');
require('../models/AuthenticatorTransportProtocol.cjs');
require('../models/JwtVerifiedCredentialFormatEnum.cjs');
require('../models/ProviderEnum.cjs');
require('../models/WalletAddressType.cjs');
require('../models/EcdsaValidatorOptions.cjs');
require('../models/EmbeddedWalletVersionEnum.cjs');
require('../models/HardwareWalletEnum.cjs');
require('../models/PasswordSourceTypeEnum.cjs');
require('../models/ProviderEntryPointVersionEnum.cjs');
require('../models/ProviderKernelVersionEnum.cjs');
require('../models/ThresholdSignatureScheme.cjs');
require('../models/WalletProviderEnum.cjs');
require('../models/MfaBackupCodeAcknowledgement.cjs');
require('../models/CustomFieldType.cjs');
require('../models/KycFieldType.cjs');
require('../models/BillingSubscriptionPlanTypeEnum.cjs');
require('../models/UnprocessableEntityErrorCode.cjs');
require('../models/ChainEnum.cjs');
require('../models/ChainalysisCheckResultEnum.cjs');
require('../models/MFADeviceType.cjs');
require('../models/EmbeddedWalletChainEnum.cjs');
require('../models/EmbeddedWalletProviderEnum.cjs');
require('../models/UserIdentifierTypeEnum.cjs');
require('../models/WaasChainEnum.cjs');
require('../models/CurrencyType.cjs');
require('../models/CustomHostnameStatusEnum.cjs');
require('../models/CustomHostnameUsageEnum.cjs');
require('../models/CustomHostnameVerificationType.cjs');
require('../models/DnsRecordType.cjs');
require('../models/TimeUnitEnum.cjs');
require('../models/EmbeddedWalletAuthType.cjs');
require('../models/EmbeddedWalletSecurityMethod.cjs');
require('../models/EnvironmentEnum.cjs');
require('../models/Network.cjs');
require('../models/ExternalWalletFundingTokenRule.cjs');
require('../models/OnrampProviders.cjs');
require('../models/SignInProviderEnum.cjs');
require('../models/SocialSignInProviderEnum.cjs');
require('../models/WaasBackupOptionsEnum.cjs');
require('../models/SdkViewSectionAlignment.cjs');
require('../models/SdkViewSectionType.cjs');
require('../models/SdkViewType.cjs');
require('../models/ZerodevBundlerProvider.cjs');
require('../models/ExportFormatEnum.cjs');
require('../models/ExportModelEnum.cjs');
require('../models/ExportStatusEnum.cjs');
require('../models/ExternalWalletFundingDefaultChain.cjs');
require('../models/GateRuleType.cjs');
var GlobalWalletAccessControlDomainCreateRequest = require('../models/GlobalWalletAccessControlDomainCreateRequest.cjs');
var GlobalWalletAccessControlDomainResponse = require('../models/GlobalWalletAccessControlDomainResponse.cjs');
var GlobalWalletAccessControlResponse = require('../models/GlobalWalletAccessControlResponse.cjs');
require('../models/GlobalWalletAccessControlTypeEnum.cjs');
var GlobalWalletAccessControlUpdateRequest = require('../models/GlobalWalletAccessControlUpdateRequest.cjs');
require('../models/HealthcheckStatus.cjs');
require('../models/InviteStatusEnum.cjs');
require('../models/RoleEnum.cjs');
require('../models/PublicKeyCredentialType.cjs');
require('../models/NextViewEnum.cjs');
require('../models/OauthResultStatus.cjs');
require('../models/WhenToImplementEnum.cjs');
require('../models/PublishEventsEvents.cjs');
require('../models/SubscriptionAdvancedScopeEnum.cjs');
require('../models/SubscriptionFreeScopeEnum.cjs');
require('../models/UserFieldsCheckEnum.cjs');
require('../models/UserFilterableFieldsEnum.cjs');
require('../models/VisitorFilterableFieldsEnum.cjs');

/* tslint:disable */
/**
 *
 */
class GlobalWalletAccessControlApi extends runtime.BaseAPI {
    /**
     * Adds a domain to be allowed or blocked for global wallet access for this project environment
     */
    addGlobalWalletAccessControlDomainRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling addGlobalWalletAccessControlDomain.');
            }
            if (requestParameters.globalWalletAccessControlDomainCreateRequest === null || requestParameters.globalWalletAccessControlDomainCreateRequest === undefined) {
                throw new runtime.RequiredError('globalWalletAccessControlDomainCreateRequest', 'Required parameter requestParameters.globalWalletAccessControlDomainCreateRequest was null or undefined when calling addGlobalWalletAccessControlDomain.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl/domains`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: GlobalWalletAccessControlDomainCreateRequest.GlobalWalletAccessControlDomainCreateRequestToJSON(requestParameters.globalWalletAccessControlDomainCreateRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => GlobalWalletAccessControlDomainResponse.GlobalWalletAccessControlDomainResponseFromJSON(jsonValue));
        });
    }
    /**
     * Adds a domain to be allowed or blocked for global wallet access for this project environment
     */
    addGlobalWalletAccessControlDomain(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.addGlobalWalletAccessControlDomainRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Creates a global wallet access control for this project environment
     */
    createGlobalWalletAccessControlRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling createGlobalWalletAccessControl.');
            }
            if (requestParameters.globalWalletAccessControlUpdateRequest === null || requestParameters.globalWalletAccessControlUpdateRequest === undefined) {
                throw new runtime.RequiredError('globalWalletAccessControlUpdateRequest', 'Required parameter requestParameters.globalWalletAccessControlUpdateRequest was null or undefined when calling createGlobalWalletAccessControl.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: GlobalWalletAccessControlUpdateRequest.GlobalWalletAccessControlUpdateRequestToJSON(requestParameters.globalWalletAccessControlUpdateRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => GlobalWalletAccessControlResponse.GlobalWalletAccessControlResponseFromJSON(jsonValue));
        });
    }
    /**
     * Creates a global wallet access control for this project environment
     */
    createGlobalWalletAccessControl(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createGlobalWalletAccessControlRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Delete a global wallet access control domain by id
     */
    deleteGlobalWalletAccessControlDomainByIdRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling deleteGlobalWalletAccessControlDomainById.');
            }
            if (requestParameters.globalWalletAccessControlDomainId === null || requestParameters.globalWalletAccessControlDomainId === undefined) {
                throw new runtime.RequiredError('globalWalletAccessControlDomainId', 'Required parameter requestParameters.globalWalletAccessControlDomainId was null or undefined when calling deleteGlobalWalletAccessControlDomainById.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl/domains/{globalWalletAccessControlDomainId}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"globalWalletAccessControlDomainId"}}`, encodeURIComponent(String(requestParameters.globalWalletAccessControlDomainId))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * Delete a global wallet access control domain by id
     */
    deleteGlobalWalletAccessControlDomainById(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.deleteGlobalWalletAccessControlDomainByIdRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Disabled global wallet access control for this environment
     */
    disableGlobalWalletAccessControlRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling disableGlobalWalletAccessControl.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl/disable`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => GlobalWalletAccessControlResponse.GlobalWalletAccessControlResponseFromJSON(jsonValue));
        });
    }
    /**
     * Disabled global wallet access control for this environment
     */
    disableGlobalWalletAccessControl(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.disableGlobalWalletAccessControlRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Enable global wallet access control for this environment
     */
    enableGlobalWalletAccessControlRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling enableGlobalWalletAccessControl.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl/enable`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => GlobalWalletAccessControlResponse.GlobalWalletAccessControlResponseFromJSON(jsonValue));
        });
    }
    /**
     * Enable global wallet access control for this environment
     */
    enableGlobalWalletAccessControl(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.enableGlobalWalletAccessControlRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get all the global wallet access control domains for a project environment
     */
    getGlobalWalletAccessControlListRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getGlobalWalletAccessControlList.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => GlobalWalletAccessControlResponse.GlobalWalletAccessControlResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get all the global wallet access control domains for a project environment
     */
    getGlobalWalletAccessControlList(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getGlobalWalletAccessControlListRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Updates a global wallet access control for this project environment
     */
    updateGlobalWalletAccessControlRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling updateGlobalWalletAccessControl.');
            }
            if (requestParameters.globalWalletAccessControlUpdateRequest === null || requestParameters.globalWalletAccessControlUpdateRequest === undefined) {
                throw new runtime.RequiredError('globalWalletAccessControlUpdateRequest', 'Required parameter requestParameters.globalWalletAccessControlUpdateRequest was null or undefined when calling updateGlobalWalletAccessControl.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/globalWallet/accessControl`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
                body: GlobalWalletAccessControlUpdateRequest.GlobalWalletAccessControlUpdateRequestToJSON(requestParameters.globalWalletAccessControlUpdateRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => GlobalWalletAccessControlResponse.GlobalWalletAccessControlResponseFromJSON(jsonValue));
        });
    }
    /**
     * Updates a global wallet access control for this project environment
     */
    updateGlobalWalletAccessControl(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.updateGlobalWalletAccessControlRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
}

exports.GlobalWalletAccessControlApi = GlobalWalletAccessControlApi;
