import { __awaiter } from '../../_virtual/_tslib.js';
import { BaseAPI, RequiredError, VoidApiResponse } from '../runtime.js';

/* tslint:disable */
/**
 *
 */
class MfaApi extends BaseAPI {
    /**
     * Delete all MFA Devices for the user
     */
    resetAllMfaDevicesRaw(requestParameters, initOverrides) {
        return __awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling resetAllMfaDevices.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}/mfa`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new VoidApiResponse(response);
        });
    }
    /**
     * Delete all MFA Devices for the user
     */
    resetAllMfaDevices(requestParameters, initOverrides) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.resetAllMfaDevicesRaw(requestParameters, initOverrides);
        });
    }
}

export { MfaApi };
