'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('../../_virtual/_tslib.cjs');
var runtime = require('../runtime.cjs');
require('../models/AccessOutcomeEnum.cjs');
require('../models/ExchangeKeyEnum.cjs');
require('../models/AttestationConveyancePreference.cjs');
require('../models/AuthModeEnum.cjs');
require('../models/AuthStorageEnum.cjs');
require('../models/AuthenticatorAttachment.cjs');
require('../models/ResidentKeyRequirement.cjs');
require('../models/UserVerificationRequirement.cjs');
require('../models/AuthenticatorTransportProtocol.cjs');
require('../models/JwtVerifiedCredentialFormatEnum.cjs');
require('../models/ProviderEnum.cjs');
require('../models/WalletAddressType.cjs');
require('../models/EcdsaValidatorOptions.cjs');
require('../models/EmbeddedWalletVersionEnum.cjs');
require('../models/HardwareWalletEnum.cjs');
require('../models/PasswordSourceTypeEnum.cjs');
require('../models/ProviderEntryPointVersionEnum.cjs');
require('../models/ProviderKernelVersionEnum.cjs');
require('../models/ThresholdSignatureScheme.cjs');
require('../models/WalletProviderEnum.cjs');
require('../models/MfaBackupCodeAcknowledgement.cjs');
require('../models/CustomFieldType.cjs');
require('../models/KycFieldType.cjs');
require('../models/BillingSubscriptionPlanTypeEnum.cjs');
require('../models/UnprocessableEntityErrorCode.cjs');
require('../models/ChainEnum.cjs');
require('../models/ChainalysisCheckResultEnum.cjs');
require('../models/MFADeviceType.cjs');
require('../models/EmbeddedWalletChainEnum.cjs');
require('../models/EmbeddedWalletProviderEnum.cjs');
require('../models/UserIdentifierTypeEnum.cjs');
require('../models/WaasChainEnum.cjs');
require('../models/CurrencyType.cjs');
require('../models/CustomHostnameStatusEnum.cjs');
require('../models/CustomHostnameUsageEnum.cjs');
require('../models/CustomHostnameVerificationType.cjs');
require('../models/DnsRecordType.cjs');
require('../models/TimeUnitEnum.cjs');
require('../models/EmbeddedWalletAuthType.cjs');
require('../models/EmbeddedWalletSecurityMethod.cjs');
require('../models/EnvironmentEnum.cjs');
require('../models/Network.cjs');
require('../models/ExternalWalletFundingTokenRule.cjs');
require('../models/OnrampProviders.cjs');
require('../models/SignInProviderEnum.cjs');
require('../models/SocialSignInProviderEnum.cjs');
require('../models/WaasBackupOptionsEnum.cjs');
require('../models/SdkViewSectionAlignment.cjs');
require('../models/SdkViewSectionType.cjs');
require('../models/SdkViewType.cjs');
require('../models/ZerodevBundlerProvider.cjs');
require('../models/ExportFormatEnum.cjs');
require('../models/ExportModelEnum.cjs');
require('../models/ExportStatusEnum.cjs');
require('../models/ExternalWalletFundingDefaultChain.cjs');
require('../models/GateRuleType.cjs');
require('../models/GlobalWalletAccessControlTypeEnum.cjs');
require('../models/HealthcheckStatus.cjs');
require('../models/InviteStatusEnum.cjs');
require('../models/RoleEnum.cjs');
require('../models/PublicKeyCredentialType.cjs');
var NameServiceCreateRequest = require('../models/NameServiceCreateRequest.cjs');
var NameServiceResponse = require('../models/NameServiceResponse.cjs');
var NameServiceSigningMessage = require('../models/NameServiceSigningMessage.cjs');
var NameServiceSigningMessageRequest = require('../models/NameServiceSigningMessageRequest.cjs');
require('../models/NextViewEnum.cjs');
require('../models/OauthResultStatus.cjs');
require('../models/WhenToImplementEnum.cjs');
require('../models/PublishEventsEvents.cjs');
require('../models/SubscriptionAdvancedScopeEnum.cjs');
require('../models/SubscriptionFreeScopeEnum.cjs');
require('../models/UserFieldsCheckEnum.cjs');
require('../models/UserFilterableFieldsEnum.cjs');
require('../models/VisitorFilterableFieldsEnum.cjs');

/* tslint:disable */
/**
 *
 */
class NameServicesApi extends runtime.BaseAPI {
    /**
     * Create a new name service for the environment and chain
     */
    createNameServiceRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling createNameService.');
            }
            if (requestParameters.chainName === null || requestParameters.chainName === undefined) {
                throw new runtime.RequiredError('chainName', 'Required parameter requestParameters.chainName was null or undefined when calling createNameService.');
            }
            if (requestParameters.nameServiceCreateRequest === null || requestParameters.nameServiceCreateRequest === undefined) {
                throw new runtime.RequiredError('nameServiceCreateRequest', 'Required parameter requestParameters.nameServiceCreateRequest was null or undefined when calling createNameService.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            const response = yield this.request({
                path: `/environments/{environmentId}/nameService/{chainName}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"chainName"}}`, encodeURIComponent(String(requestParameters.chainName))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: NameServiceCreateRequest.NameServiceCreateRequestToJSON(requestParameters.nameServiceCreateRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => NameServiceResponse.NameServiceResponseFromJSON(jsonValue));
        });
    }
    /**
     * Create a new name service for the environment and chain
     */
    createNameService(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createNameServiceRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * delete the name service for the environment and chain
     */
    deleteNameServiceRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling deleteNameService.');
            }
            if (requestParameters.chainName === null || requestParameters.chainName === undefined) {
                throw new runtime.RequiredError('chainName', 'Required parameter requestParameters.chainName was null or undefined when calling deleteNameService.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/environments/{environmentId}/nameService/{chainName}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"chainName"}}`, encodeURIComponent(String(requestParameters.chainName))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * delete the name service for the environment and chain
     */
    deleteNameService(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.deleteNameServiceRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Disabled name service for this environment and chain
     */
    disableNameServiceRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling disableNameService.');
            }
            if (requestParameters.chainName === null || requestParameters.chainName === undefined) {
                throw new runtime.RequiredError('chainName', 'Required parameter requestParameters.chainName was null or undefined when calling disableNameService.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/environments/{environmentId}/nameService/{chainName}/disable`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"chainName"}}`, encodeURIComponent(String(requestParameters.chainName))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => NameServiceResponse.NameServiceResponseFromJSON(jsonValue));
        });
    }
    /**
     * Disabled name service for this environment and chain
     */
    disableNameService(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.disableNameServiceRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Enable name service for this environment and chain
     */
    enableNameServiceRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling enableNameService.');
            }
            if (requestParameters.chainName === null || requestParameters.chainName === undefined) {
                throw new runtime.RequiredError('chainName', 'Required parameter requestParameters.chainName was null or undefined when calling enableNameService.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/environments/{environmentId}/nameService/{chainName}/enable`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"chainName"}}`, encodeURIComponent(String(requestParameters.chainName))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => NameServiceResponse.NameServiceResponseFromJSON(jsonValue));
        });
    }
    /**
     * Enable name service for this environment and chain
     */
    enableNameService(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.enableNameServiceRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get the unsigned chain-specific message needed to be signed by the wallet owner using the wallet private key
     */
    fetchNameServiceSigningMessageRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling fetchNameServiceSigningMessage.');
            }
            if (requestParameters.chainName === null || requestParameters.chainName === undefined) {
                throw new runtime.RequiredError('chainName', 'Required parameter requestParameters.chainName was null or undefined when calling fetchNameServiceSigningMessage.');
            }
            if (requestParameters.nameServiceSigningMessageRequest === null || requestParameters.nameServiceSigningMessageRequest === undefined) {
                throw new runtime.RequiredError('nameServiceSigningMessageRequest', 'Required parameter requestParameters.nameServiceSigningMessageRequest was null or undefined when calling fetchNameServiceSigningMessage.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            const response = yield this.request({
                path: `/environments/{environmentId}/nameService/{chainName}/signingMessage`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"chainName"}}`, encodeURIComponent(String(requestParameters.chainName))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: NameServiceSigningMessageRequest.NameServiceSigningMessageRequestToJSON(requestParameters.nameServiceSigningMessageRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => NameServiceSigningMessage.NameServiceSigningMessageFromJSON(jsonValue));
        });
    }
    /**
     * Get the unsigned chain-specific message needed to be signed by the wallet owner using the wallet private key
     */
    fetchNameServiceSigningMessage(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.fetchNameServiceSigningMessageRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get the name service for the environment and chain
     */
    getNameServiceRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getNameService.');
            }
            if (requestParameters.chainName === null || requestParameters.chainName === undefined) {
                throw new runtime.RequiredError('chainName', 'Required parameter requestParameters.chainName was null or undefined when calling getNameService.');
            }
            const queryParameters = {};
            const headerParameters = {};
            const response = yield this.request({
                path: `/environments/{environmentId}/nameService/{chainName}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"chainName"}}`, encodeURIComponent(String(requestParameters.chainName))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => NameServiceResponse.NameServiceResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get the name service for the environment and chain
     */
    getNameService(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getNameServiceRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
}

exports.NameServicesApi = NameServicesApi;
