'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('../../_virtual/_tslib.cjs');
var runtime = require('../runtime.cjs');
require('../models/AccessOutcomeEnum.cjs');
require('../models/ExchangeKeyEnum.cjs');
require('../models/AttestationConveyancePreference.cjs');
require('../models/AuthModeEnum.cjs');
require('../models/AuthStorageEnum.cjs');
require('../models/AuthenticatorAttachment.cjs');
require('../models/ResidentKeyRequirement.cjs');
require('../models/UserVerificationRequirement.cjs');
require('../models/AuthenticatorTransportProtocol.cjs');
require('../models/JwtVerifiedCredentialFormatEnum.cjs');
require('../models/ProviderEnum.cjs');
require('../models/WalletAddressType.cjs');
require('../models/EcdsaValidatorOptions.cjs');
require('../models/EmbeddedWalletVersionEnum.cjs');
require('../models/HardwareWalletEnum.cjs');
require('../models/PasswordSourceTypeEnum.cjs');
require('../models/ProviderEntryPointVersionEnum.cjs');
require('../models/ProviderKernelVersionEnum.cjs');
require('../models/ThresholdSignatureScheme.cjs');
require('../models/WalletProviderEnum.cjs');
require('../models/MfaBackupCodeAcknowledgement.cjs');
require('../models/CustomFieldType.cjs');
require('../models/KycFieldType.cjs');
require('../models/BillingSubscriptionPlanTypeEnum.cjs');
var BulkUserCreateResponse = require('../models/BulkUserCreateResponse.cjs');
require('../models/UnprocessableEntityErrorCode.cjs');
require('../models/ChainEnum.cjs');
require('../models/ChainalysisCheckResultEnum.cjs');
require('../models/MFADeviceType.cjs');
require('../models/EmbeddedWalletChainEnum.cjs');
require('../models/EmbeddedWalletProviderEnum.cjs');
require('../models/UserIdentifierTypeEnum.cjs');
require('../models/WaasChainEnum.cjs');
require('../models/CurrencyType.cjs');
require('../models/CustomHostnameStatusEnum.cjs');
require('../models/CustomHostnameUsageEnum.cjs');
require('../models/CustomHostnameVerificationType.cjs');
require('../models/DnsRecordType.cjs');
require('../models/TimeUnitEnum.cjs');
require('../models/EmbeddedWalletAuthType.cjs');
require('../models/EmbeddedWalletSecurityMethod.cjs');
require('../models/EnvironmentEnum.cjs');
require('../models/Network.cjs');
require('../models/ExternalWalletFundingTokenRule.cjs');
require('../models/OnrampProviders.cjs');
require('../models/SignInProviderEnum.cjs');
require('../models/SocialSignInProviderEnum.cjs');
require('../models/WaasBackupOptionsEnum.cjs');
require('../models/SdkViewSectionAlignment.cjs');
require('../models/SdkViewSectionType.cjs');
require('../models/SdkViewType.cjs');
require('../models/ZerodevBundlerProvider.cjs');
require('../models/ExportFormatEnum.cjs');
require('../models/ExportModelEnum.cjs');
require('../models/ExportStatusEnum.cjs');
require('../models/ExternalWalletFundingDefaultChain.cjs');
require('../models/GateRuleType.cjs');
require('../models/GlobalWalletAccessControlTypeEnum.cjs');
require('../models/HealthcheckStatus.cjs');
var InternalBulkUpdateUserFields = require('../models/InternalBulkUpdateUserFields.cjs');
var InternalUpdatableUserFields = require('../models/InternalUpdatableUserFields.cjs');
var InternalUserFields = require('../models/InternalUserFields.cjs');
require('../models/InviteStatusEnum.cjs');
require('../models/RoleEnum.cjs');
require('../models/PublicKeyCredentialType.cjs');
require('../models/NextViewEnum.cjs');
require('../models/OauthResultStatus.cjs');
require('../models/WhenToImplementEnum.cjs');
require('../models/PublishEventsEvents.cjs');
require('../models/SubscriptionAdvancedScopeEnum.cjs');
require('../models/SubscriptionFreeScopeEnum.cjs');
require('../models/UserFieldsCheckEnum.cjs');
require('../models/UserFilterableFieldsEnum.cjs');
var UserOauthAccessTokenResponse = require('../models/UserOauthAccessTokenResponse.cjs');
var UserResponse = require('../models/UserResponse.cjs');
var UsersResponse = require('../models/UsersResponse.cjs');
require('../models/VisitorFilterableFieldsEnum.cjs');

/* tslint:disable */
/**
 *
 */
class UsersApi extends runtime.BaseAPI {
    /**
     * Creates many new users
     */
    bulkCreateUserRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling bulkCreateUser.');
            }
            if (requestParameters.internalUserFields === null || requestParameters.internalUserFields === undefined) {
                throw new runtime.RequiredError('internalUserFields', 'Required parameter requestParameters.internalUserFields was null or undefined when calling bulkCreateUser.');
            }
            const queryParameters = {};
            if (requestParameters.upsert !== undefined) {
                queryParameters['upsert'] = requestParameters.upsert;
            }
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/bulk`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: requestParameters.internalUserFields.map(InternalUserFields.InternalUserFieldsToJSON),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => BulkUserCreateResponse.BulkUserCreateResponseFromJSON(jsonValue));
        });
    }
    /**
     * Creates many new users
     */
    bulkCreateUser(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.bulkCreateUserRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Creates a new user
     */
    createUserRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling createUser.');
            }
            if (requestParameters.internalBulkUpdateUserFields === null || requestParameters.internalBulkUpdateUserFields === undefined) {
                throw new runtime.RequiredError('internalBulkUpdateUserFields', 'Required parameter requestParameters.internalBulkUpdateUserFields was null or undefined when calling createUser.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: InternalBulkUpdateUserFields.InternalBulkUpdateUserFieldsToJSON(requestParameters.internalBulkUpdateUserFields),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Creates a new user
     */
    createUser(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createUserRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Delete user
     */
    deleteUserRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling deleteUser.');
            }
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling deleteUser.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/{userId}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * Delete user
     */
    deleteUser(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.deleteUserRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Delete user (deprecated - use /environments/{environmentId}/users/{userId} instead)
     */
    deleteUserLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling deleteUserLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * Delete user (deprecated - use /environments/{environmentId}/users/{userId} instead)
     */
    deleteUserLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.deleteUserLegacyRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Get all users for an environment
     */
    getEnvironmentUsersRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getEnvironmentUsers.');
            }
            const queryParameters = {};
            if (requestParameters.filter !== undefined) {
                queryParameters['filter'] = requestParameters.filter;
            }
            if (requestParameters.orderBy !== undefined) {
                queryParameters['orderBy'] = requestParameters.orderBy;
            }
            if (requestParameters.offset !== undefined) {
                queryParameters['offset'] = requestParameters.offset;
            }
            if (requestParameters.limit !== undefined) {
                queryParameters['limit'] = requestParameters.limit;
            }
            if (requestParameters.includeSessions !== undefined) {
                queryParameters['includeSessions'] = requestParameters.includeSessions;
            }
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UsersResponse.UsersResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get all users for an environment
     */
    getEnvironmentUsers(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getEnvironmentUsersRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get a user by Id
     */
    getUserRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getUser.');
            }
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling getUser.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/{userId}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get a user by Id
     */
    getUser(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getUserRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get a user by Id (deprecated - use /environments/{environmentId}/users/{userId} instead)
     */
    getUserLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling getUserLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get a user by Id (deprecated - use /environments/{environmentId}/users/{userId} instead)
     */
    getUserLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getUserLegacyRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get the access token for a user OAuth account
     */
    getUserOauthAccessTokenRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.oauthAccountId === null || requestParameters.oauthAccountId === undefined) {
                throw new runtime.RequiredError('oauthAccountId', 'Required parameter requestParameters.oauthAccountId was null or undefined when calling getUserOauthAccessToken.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/oauthAccounts/{oauthAccountId}/accessToken`.replace(`{${"oauthAccountId"}}`, encodeURIComponent(String(requestParameters.oauthAccountId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserOauthAccessTokenResponse.UserOauthAccessTokenResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get the access token for a user OAuth account
     */
    getUserOauthAccessToken(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getUserOauthAccessTokenRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Revoke sessions by user ID
     */
    revokeUserSessionsRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling revokeUserSessions.');
            }
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling revokeUserSessions.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/{userId}/sessions/revoke`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * Revoke sessions by user ID
     */
    revokeUserSessions(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.revokeUserSessionsRaw(requestParameters, initOverrides);
        });
    }
    /**
     * This endpoint is deprecated. Use /environments/{environmentId}/users/{userId}/sessions/revoke instead.
     * Revoke sessions by user ID
     */
    revokeUserSessionsLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling revokeUserSessionsLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}/sessions/revoke`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * This endpoint is deprecated. Use /environments/{environmentId}/users/{userId}/sessions/revoke instead.
     * Revoke sessions by user ID
     */
    revokeUserSessionsLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.revokeUserSessionsLegacyRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Update a user
     */
    updateUserRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling updateUser.');
            }
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling updateUser.');
            }
            if (requestParameters.internalUpdatableUserFields === null || requestParameters.internalUpdatableUserFields === undefined) {
                throw new runtime.RequiredError('internalUpdatableUserFields', 'Required parameter requestParameters.internalUpdatableUserFields was null or undefined when calling updateUser.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/{userId}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
                body: InternalUpdatableUserFields.InternalUpdatableUserFieldsToJSON(requestParameters.internalUpdatableUserFields),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Update a user
     */
    updateUser(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.updateUserRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Update a user (deprecated - use /environments/{environmentId}/users/{userId} instead)
     */
    updateUserLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling updateUserLegacy.');
            }
            if (requestParameters.internalUpdatableUserFields === null || requestParameters.internalUpdatableUserFields === undefined) {
                throw new runtime.RequiredError('internalUpdatableUserFields', 'Required parameter requestParameters.internalUpdatableUserFields was null or undefined when calling updateUserLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'PUT',
                headers: headerParameters,
                query: queryParameters,
                body: InternalUpdatableUserFields.InternalUpdatableUserFieldsToJSON(requestParameters.internalUpdatableUserFields),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Update a user (deprecated - use /environments/{environmentId}/users/{userId} instead)
     */
    updateUserLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.updateUserLegacyRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
}

exports.UsersApi = UsersApi;
