'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('../../_virtual/_tslib.cjs');
var runtime = require('../runtime.cjs');
require('../models/AccessOutcomeEnum.cjs');
require('../models/ExchangeKeyEnum.cjs');
require('../models/AttestationConveyancePreference.cjs');
require('../models/AuthModeEnum.cjs');
require('../models/AuthStorageEnum.cjs');
require('../models/AuthenticatorAttachment.cjs');
require('../models/ResidentKeyRequirement.cjs');
require('../models/UserVerificationRequirement.cjs');
require('../models/AuthenticatorTransportProtocol.cjs');
require('../models/JwtVerifiedCredentialFormatEnum.cjs');
require('../models/ProviderEnum.cjs');
require('../models/WalletAddressType.cjs');
require('../models/EcdsaValidatorOptions.cjs');
var EmbeddedWalletVersionEnum = require('../models/EmbeddedWalletVersionEnum.cjs');
require('../models/HardwareWalletEnum.cjs');
require('../models/PasswordSourceTypeEnum.cjs');
require('../models/ProviderEntryPointVersionEnum.cjs');
require('../models/ProviderKernelVersionEnum.cjs');
require('../models/ThresholdSignatureScheme.cjs');
require('../models/WalletProviderEnum.cjs');
require('../models/MfaBackupCodeAcknowledgement.cjs');
require('../models/CustomFieldType.cjs');
require('../models/KycFieldType.cjs');
require('../models/BillingSubscriptionPlanTypeEnum.cjs');
require('../models/UnprocessableEntityErrorCode.cjs');
require('../models/ChainEnum.cjs');
require('../models/ChainalysisCheckResultEnum.cjs');
require('../models/MFADeviceType.cjs');
var Wallet = require('../models/Wallet.cjs');
require('../models/EmbeddedWalletChainEnum.cjs');
require('../models/EmbeddedWalletProviderEnum.cjs');
var CreateUserEmbeddedWalletsFromFarcasterRequest = require('../models/CreateUserEmbeddedWalletsFromFarcasterRequest.cjs');
var CreateUserEmbeddedWalletsRequest = require('../models/CreateUserEmbeddedWalletsRequest.cjs');
require('../models/WaasChainEnum.cjs');
var CreateWalletRequest = require('../models/CreateWalletRequest.cjs');
require('../models/CurrencyType.cjs');
require('../models/CustomHostnameStatusEnum.cjs');
require('../models/CustomHostnameUsageEnum.cjs');
require('../models/CustomHostnameVerificationType.cjs');
require('../models/DnsRecordType.cjs');
require('../models/TimeUnitEnum.cjs');
require('../models/EmbeddedWalletAuthType.cjs');
require('../models/EmbeddedWalletSecurityMethod.cjs');
require('../models/EnvironmentEnum.cjs');
require('../models/Network.cjs');
require('../models/ExternalWalletFundingTokenRule.cjs');
require('../models/OnrampProviders.cjs');
require('../models/SignInProviderEnum.cjs');
require('../models/SocialSignInProviderEnum.cjs');
require('../models/WaasBackupOptionsEnum.cjs');
require('../models/SdkViewSectionAlignment.cjs');
require('../models/SdkViewSectionType.cjs');
require('../models/SdkViewType.cjs');
require('../models/ZerodevBundlerProvider.cjs');
require('../models/ExportFormatEnum.cjs');
require('../models/ExportModelEnum.cjs');
require('../models/ExportStatusEnum.cjs');
require('../models/ExternalWalletFundingDefaultChain.cjs');
require('../models/GateRuleType.cjs');
require('../models/GlobalWalletAccessControlTypeEnum.cjs');
require('../models/HealthcheckStatus.cjs');
require('../models/InviteStatusEnum.cjs');
require('../models/RoleEnum.cjs');
require('../models/PublicKeyCredentialType.cjs');
require('../models/NextViewEnum.cjs');
require('../models/OauthResultStatus.cjs');
require('../models/WhenToImplementEnum.cjs');
require('../models/PublishEventsEvents.cjs');
require('../models/SubscriptionAdvancedScopeEnum.cjs');
require('../models/SubscriptionFreeScopeEnum.cjs');
require('../models/UserFieldsCheckEnum.cjs');
require('../models/UserFilterableFieldsEnum.cjs');
require('../models/UserIdentifierTypeEnum.cjs');
var UserResponse = require('../models/UserResponse.cjs');
var UserWalletsResponse = require('../models/UserWalletsResponse.cjs');
require('../models/VisitorFilterableFieldsEnum.cjs');

/* tslint:disable */
/**
 *
 */
class WalletsApi extends runtime.BaseAPI {
    /**
     * Creates a new embedded wallet for a user given an email or userId. If an email is provided and it is not associated with an existing user this call will also create a new user.
     * Creates a new embedded wallet for a user given an identifier
     */
    createEmbeddedWalletRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling createEmbeddedWallet.');
            }
            if (requestParameters.createUserEmbeddedWalletsRequest === null || requestParameters.createUserEmbeddedWalletsRequest === undefined) {
                throw new runtime.RequiredError('createUserEmbeddedWalletsRequest', 'Required parameter requestParameters.createUserEmbeddedWalletsRequest was null or undefined when calling createEmbeddedWallet.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/embeddedWallets`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: CreateUserEmbeddedWalletsRequest.CreateUserEmbeddedWalletsRequestToJSON(requestParameters.createUserEmbeddedWalletsRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Creates a new embedded wallet for a user given an email or userId. If an email is provided and it is not associated with an existing user this call will also create a new user.
     * Creates a new embedded wallet for a user given an identifier
     */
    createEmbeddedWallet(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createEmbeddedWalletRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     */
    createEmbeddedWalletFromFarcasterRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling createEmbeddedWalletFromFarcaster.');
            }
            if (requestParameters.createUserEmbeddedWalletsFromFarcasterRequest === null || requestParameters.createUserEmbeddedWalletsFromFarcasterRequest === undefined) {
                throw new runtime.RequiredError('createUserEmbeddedWalletsFromFarcasterRequest', 'Required parameter requestParameters.createUserEmbeddedWalletsFromFarcasterRequest was null or undefined when calling createEmbeddedWalletFromFarcaster.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/embeddedWallets/farcaster`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: CreateUserEmbeddedWalletsFromFarcasterRequest.CreateUserEmbeddedWalletsFromFarcasterRequestToJSON(requestParameters.createUserEmbeddedWalletsFromFarcasterRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserResponse.UserResponseFromJSON(jsonValue));
        });
    }
    /**
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     */
    createEmbeddedWalletFromFarcaster(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createEmbeddedWalletFromFarcasterRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user. Note that if the user already has an embedded wallet linked, this call will fail.
     */
    createWalletRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling createWallet.');
            }
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling createWallet.');
            }
            if (requestParameters.createWalletRequest === null || requestParameters.createWalletRequest === undefined) {
                throw new runtime.RequiredError('createWalletRequest', 'Required parameter requestParameters.createWalletRequest was null or undefined when calling createWallet.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/{userId}/wallets`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: CreateWalletRequest.CreateWalletRequestToJSON(requestParameters.createWalletRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => Wallet.WalletFromJSON(jsonValue));
        });
    }
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user. Note that if the user already has an embedded wallet linked, this call will fail.
     */
    createWallet(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createWalletRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    createWalletLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling createWalletLegacy.');
            }
            if (requestParameters.createWalletRequest === null || requestParameters.createWalletRequest === undefined) {
                throw new runtime.RequiredError('createWalletRequest', 'Required parameter requestParameters.createWalletRequest was null or undefined when calling createWalletLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            headerParameters['Content-Type'] = 'application/json';
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}/wallets`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'POST',
                headers: headerParameters,
                query: queryParameters,
                body: CreateWalletRequest.CreateWalletRequestToJSON(requestParameters.createWalletRequest),
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => Wallet.WalletFromJSON(jsonValue));
        });
    }
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    createWalletLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.createWalletLegacyRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Delete wallet
     */
    deleteWalletByIdRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling deleteWalletById.');
            }
            if (requestParameters.walletId === null || requestParameters.walletId === undefined) {
                throw new runtime.RequiredError('walletId', 'Required parameter requestParameters.walletId was null or undefined when calling deleteWalletById.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/wallets/{walletId}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"walletId"}}`, encodeURIComponent(String(requestParameters.walletId))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * Delete wallet
     */
    deleteWalletById(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.deleteWalletByIdRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Delete wallet (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    deleteWalletByIdLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.walletId === null || requestParameters.walletId === undefined) {
                throw new runtime.RequiredError('walletId', 'Required parameter requestParameters.walletId was null or undefined when calling deleteWalletByIdLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/wallets/{walletId}`.replace(`{${"walletId"}}`, encodeURIComponent(String(requestParameters.walletId))),
                method: 'DELETE',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.VoidApiResponse(response);
        });
    }
    /**
     * Delete wallet (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    deleteWalletByIdLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            yield this.deleteWalletByIdLegacyRaw(requestParameters, initOverrides);
        });
    }
    /**
     * Get the active embedded wallet versions for an environment
     */
    getActiveEmbeddedWalletVersionsForEnvironmentRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getActiveEmbeddedWalletVersionsForEnvironment.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/embeddedWalletVersions`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => jsonValue.map(EmbeddedWalletVersionEnum.EmbeddedWalletVersionEnumFromJSON));
        });
    }
    /**
     * Get the active embedded wallet versions for an environment
     */
    getActiveEmbeddedWalletVersionsForEnvironment(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getActiveEmbeddedWalletVersionsForEnvironmentRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get a wallet using the ID
     */
    getWalletByIdRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getWalletById.');
            }
            if (requestParameters.walletId === null || requestParameters.walletId === undefined) {
                throw new runtime.RequiredError('walletId', 'Required parameter requestParameters.walletId was null or undefined when calling getWalletById.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/wallets/{walletId}`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"walletId"}}`, encodeURIComponent(String(requestParameters.walletId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => Wallet.WalletFromJSON(jsonValue));
        });
    }
    /**
     * Get a wallet using the ID
     */
    getWalletById(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getWalletByIdRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get a wallet using the ID (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    getWalletByIdLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.walletId === null || requestParameters.walletId === undefined) {
                throw new runtime.RequiredError('walletId', 'Required parameter requestParameters.walletId was null or undefined when calling getWalletByIdLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/wallets/{walletId}`.replace(`{${"walletId"}}`, encodeURIComponent(String(requestParameters.walletId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => Wallet.WalletFromJSON(jsonValue));
        });
    }
    /**
     * Get a wallet using the ID (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    getWalletByIdLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getWalletByIdLegacyRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get wallets by user
     */
    getWalletsByUserIdRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.environmentId === null || requestParameters.environmentId === undefined) {
                throw new runtime.RequiredError('environmentId', 'Required parameter requestParameters.environmentId was null or undefined when calling getWalletsByUserId.');
            }
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling getWalletsByUserId.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/environments/{environmentId}/users/{userId}/wallets`.replace(`{${"environmentId"}}`, encodeURIComponent(String(requestParameters.environmentId))).replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserWalletsResponse.UserWalletsResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get wallets by user
     */
    getWalletsByUserId(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getWalletsByUserIdRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
    /**
     * Get wallets by user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    getWalletsByUserIdLegacyRaw(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            if (requestParameters.userId === null || requestParameters.userId === undefined) {
                throw new runtime.RequiredError('userId', 'Required parameter requestParameters.userId was null or undefined when calling getWalletsByUserIdLegacy.');
            }
            const queryParameters = {};
            const headerParameters = {};
            if (this.configuration && this.configuration.accessToken) {
                const token = this.configuration.accessToken;
                const tokenString = yield token("bearerAuth", []);
                if (tokenString) {
                    headerParameters["Authorization"] = `Bearer ${tokenString}`;
                }
            }
            const response = yield this.request({
                path: `/users/{userId}/wallets`.replace(`{${"userId"}}`, encodeURIComponent(String(requestParameters.userId))),
                method: 'GET',
                headers: headerParameters,
                query: queryParameters,
            }, initOverrides);
            return new runtime.JSONApiResponse(response, (jsonValue) => UserWalletsResponse.UserWalletsResponseFromJSON(jsonValue));
        });
    }
    /**
     * Get wallets by user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    getWalletsByUserIdLegacy(requestParameters, initOverrides) {
        return _tslib.__awaiter(this, void 0, void 0, function* () {
            const response = yield this.getWalletsByUserIdLegacyRaw(requestParameters, initOverrides);
            return yield response.value();
        });
    }
}

exports.WalletsApi = WalletsApi;
