/**
 * Dashboard API
 * Dashboard API documentation
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { CreateUserEmbeddedWalletsFromFarcasterRequest, CreateUserEmbeddedWalletsRequest, CreateWalletRequest, EmbeddedWalletVersionEnum, UserResponse, UserWalletsResponse, Wallet } from '../models';
export interface CreateEmbeddedWalletRequest {
    environmentId: string;
    createUserEmbeddedWalletsRequest: CreateUserEmbeddedWalletsRequest;
}
export interface CreateEmbeddedWalletFromFarcasterRequest {
    environmentId: string;
    createUserEmbeddedWalletsFromFarcasterRequest: CreateUserEmbeddedWalletsFromFarcasterRequest;
}
export interface CreateWalletOperationRequest {
    environmentId: string;
    userId: string;
    createWalletRequest: CreateWalletRequest;
}
export interface CreateWalletLegacyRequest {
    userId: string;
    createWalletRequest: CreateWalletRequest;
}
export interface DeleteWalletByIdRequest {
    environmentId: string;
    walletId: string;
}
export interface DeleteWalletByIdLegacyRequest {
    walletId: string;
}
export interface GetActiveEmbeddedWalletVersionsForEnvironmentRequest {
    environmentId: string;
}
export interface GetWalletByIdRequest {
    environmentId: string;
    walletId: string;
}
export interface GetWalletByIdLegacyRequest {
    walletId: string;
}
export interface GetWalletsByUserIdRequest {
    environmentId: string;
    userId: string;
}
export interface GetWalletsByUserIdLegacyRequest {
    userId: string;
}
/**
 *
 */
export declare class WalletsApi extends runtime.BaseAPI {
    /**
     * Creates a new embedded wallet for a user given an email or userId. If an email is provided and it is not associated with an existing user this call will also create a new user.
     * Creates a new embedded wallet for a user given an identifier
     */
    createEmbeddedWalletRaw(requestParameters: CreateEmbeddedWalletRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<UserResponse>>;
    /**
     * Creates a new embedded wallet for a user given an email or userId. If an email is provided and it is not associated with an existing user this call will also create a new user.
     * Creates a new embedded wallet for a user given an identifier
     */
    createEmbeddedWallet(requestParameters: CreateEmbeddedWalletRequest, initOverrides?: RequestInit): Promise<UserResponse>;
    /**
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     */
    createEmbeddedWalletFromFarcasterRaw(requestParameters: CreateEmbeddedWalletFromFarcasterRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<UserResponse>>;
    /**
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     * Creates a new embedded wallet. This API is meant to be called from a frame server.
     */
    createEmbeddedWalletFromFarcaster(requestParameters: CreateEmbeddedWalletFromFarcasterRequest, initOverrides?: RequestInit): Promise<UserResponse>;
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user. Note that if the user already has an embedded wallet linked, this call will fail.
     */
    createWalletRaw(requestParameters: CreateWalletOperationRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Wallet>>;
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user. Note that if the user already has an embedded wallet linked, this call will fail.
     */
    createWallet(requestParameters: CreateWalletOperationRequest, initOverrides?: RequestInit): Promise<Wallet>;
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    createWalletLegacyRaw(requestParameters: CreateWalletLegacyRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Wallet>>;
    /**
     * Creates a new wallet for the user. Note that this API is not meant for creating embedded wallets. To create embedded wallets use the /embeddedWallets endpoint.
     * Creates a new wallet for the user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    createWalletLegacy(requestParameters: CreateWalletLegacyRequest, initOverrides?: RequestInit): Promise<Wallet>;
    /**
     * Delete wallet
     */
    deleteWalletByIdRaw(requestParameters: DeleteWalletByIdRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     * Delete wallet
     */
    deleteWalletById(requestParameters: DeleteWalletByIdRequest, initOverrides?: RequestInit): Promise<void>;
    /**
     * Delete wallet (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    deleteWalletByIdLegacyRaw(requestParameters: DeleteWalletByIdLegacyRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     * Delete wallet (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    deleteWalletByIdLegacy(requestParameters: DeleteWalletByIdLegacyRequest, initOverrides?: RequestInit): Promise<void>;
    /**
     * Get the active embedded wallet versions for an environment
     */
    getActiveEmbeddedWalletVersionsForEnvironmentRaw(requestParameters: GetActiveEmbeddedWalletVersionsForEnvironmentRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Array<EmbeddedWalletVersionEnum>>>;
    /**
     * Get the active embedded wallet versions for an environment
     */
    getActiveEmbeddedWalletVersionsForEnvironment(requestParameters: GetActiveEmbeddedWalletVersionsForEnvironmentRequest, initOverrides?: RequestInit): Promise<Array<EmbeddedWalletVersionEnum>>;
    /**
     * Get a wallet using the ID
     */
    getWalletByIdRaw(requestParameters: GetWalletByIdRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Wallet>>;
    /**
     * Get a wallet using the ID
     */
    getWalletById(requestParameters: GetWalletByIdRequest, initOverrides?: RequestInit): Promise<Wallet>;
    /**
     * Get a wallet using the ID (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    getWalletByIdLegacyRaw(requestParameters: GetWalletByIdLegacyRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Wallet>>;
    /**
     * Get a wallet using the ID (deprecated - use /environments/{environmentId}/wallets/{walletId} instead)
     */
    getWalletByIdLegacy(requestParameters: GetWalletByIdLegacyRequest, initOverrides?: RequestInit): Promise<Wallet>;
    /**
     * Get wallets by user
     */
    getWalletsByUserIdRaw(requestParameters: GetWalletsByUserIdRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<UserWalletsResponse>>;
    /**
     * Get wallets by user
     */
    getWalletsByUserId(requestParameters: GetWalletsByUserIdRequest, initOverrides?: RequestInit): Promise<UserWalletsResponse>;
    /**
     * Get wallets by user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    getWalletsByUserIdLegacyRaw(requestParameters: GetWalletsByUserIdLegacyRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<UserWalletsResponse>>;
    /**
     * Get wallets by user (deprecated - use /environments/{environmentId}/users/{userId}/wallets instead)
     */
    getWalletsByUserIdLegacy(requestParameters: GetWalletsByUserIdLegacyRequest, initOverrides?: RequestInit): Promise<UserWalletsResponse>;
}
