/**
 * Dashboard API
 * Dashboard API documentation
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { Webhook, WebhookCreateRequest, WebhookMessageRedeliveryResponse, WebhookMessagesResponse, WebhookUpdateRequest, WebhooksResponse } from '../models';
export interface CreateWebhookRequest {
    environmentId: string;
    webhookCreateRequest: WebhookCreateRequest;
}
export interface DeleteWebhookByIdRequest {
    environmentId: string;
    webhookId: string;
}
export interface GetWebhookRequest {
    environmentId: string;
    webhookId: string;
    includeSecret?: boolean;
}
export interface GetWebhookMessageDeliveriesRequest {
    environmentId: string;
    webhookId: string;
    messageId: string;
}
export interface GetWebhookMessagesRequest {
    environmentId: string;
    webhookId: string;
    cursor?: string;
}
export interface GetWebhooksRequest {
    environmentId: string;
}
export interface RedeliverWebhookMessageRequest {
    environmentId: string;
    webhookId: string;
    messageId: string;
}
export interface UpdateWebhookByIdRequest {
    environmentId: string;
    webhookId: string;
    webhookUpdateRequest: WebhookUpdateRequest;
}
/**
 *
 */
export declare class WebhooksApi extends runtime.BaseAPI {
    /**
     * Creates a new Webhooks for the project environment
     */
    createWebhookRaw(requestParameters: CreateWebhookRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Webhook>>;
    /**
     * Creates a new Webhooks for the project environment
     */
    createWebhook(requestParameters: CreateWebhookRequest, initOverrides?: RequestInit): Promise<Webhook>;
    /**
     * Delete the Webhook for an environment
     */
    deleteWebhookByIdRaw(requestParameters: DeleteWebhookByIdRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<void>>;
    /**
     * Delete the Webhook for an environment
     */
    deleteWebhookById(requestParameters: DeleteWebhookByIdRequest, initOverrides?: RequestInit): Promise<void>;
    /**
     * Get the Webhook for an environment
     */
    getWebhookRaw(requestParameters: GetWebhookRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Webhook>>;
    /**
     * Get the Webhook for an environment
     */
    getWebhook(requestParameters: GetWebhookRequest, initOverrides?: RequestInit): Promise<Webhook>;
    /**
     * Get the Message deliveries for a webhook
     */
    getWebhookMessageDeliveriesRaw(requestParameters: GetWebhookMessageDeliveriesRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<WebhookMessagesResponse>>;
    /**
     * Get the Message deliveries for a webhook
     */
    getWebhookMessageDeliveries(requestParameters: GetWebhookMessageDeliveriesRequest, initOverrides?: RequestInit): Promise<WebhookMessagesResponse>;
    /**
     * Get the Messages for an webhook
     */
    getWebhookMessagesRaw(requestParameters: GetWebhookMessagesRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<WebhookMessagesResponse>>;
    /**
     * Get the Messages for an webhook
     */
    getWebhookMessages(requestParameters: GetWebhookMessagesRequest, initOverrides?: RequestInit): Promise<WebhookMessagesResponse>;
    /**
     * Get the Webhooks for an environment
     */
    getWebhooksRaw(requestParameters: GetWebhooksRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<WebhooksResponse>>;
    /**
     * Get the Webhooks for an environment
     */
    getWebhooks(requestParameters: GetWebhooksRequest, initOverrides?: RequestInit): Promise<WebhooksResponse>;
    /**
     * Redeliver message for an webhook
     */
    redeliverWebhookMessageRaw(requestParameters: RedeliverWebhookMessageRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<WebhookMessageRedeliveryResponse>>;
    /**
     * Redeliver message for an webhook
     */
    redeliverWebhookMessage(requestParameters: RedeliverWebhookMessageRequest, initOverrides?: RequestInit): Promise<WebhookMessageRedeliveryResponse>;
    /**
     * Update the Webhook for an environment
     */
    updateWebhookByIdRaw(requestParameters: UpdateWebhookByIdRequest, initOverrides?: RequestInit): Promise<runtime.ApiResponse<Webhook>>;
    /**
     * Update the Webhook for an environment
     */
    updateWebhookById(requestParameters: UpdateWebhookByIdRequest, initOverrides?: RequestInit): Promise<Webhook>;
}
