import { exists } from '../runtime.js';
import { UnprocessableEntityErrorCodeFromJSON, UnprocessableEntityErrorCodeToJSON } from './UnprocessableEntityErrorCode.js';
import { UserFromJSON, UserToJSON } from './User.js';

/* tslint:disable */
function BulkUserCreateResponseFailedFromJSON(json) {
    return BulkUserCreateResponseFailedFromJSONTyped(json);
}
function BulkUserCreateResponseFailedFromJSONTyped(json, ignoreDiscriminator) {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        'user': !exists(json, 'user') ? undefined : UserFromJSON(json['user']),
        'error': !exists(json, 'error') ? undefined : json['error'],
        'code': !exists(json, 'code') ? undefined : UnprocessableEntityErrorCodeFromJSON(json['code']),
    };
}
function BulkUserCreateResponseFailedToJSON(value) {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        'user': UserToJSON(value.user),
        'error': value.error,
        'code': UnprocessableEntityErrorCodeToJSON(value.code),
    };
}

export { BulkUserCreateResponseFailedFromJSON, BulkUserCreateResponseFailedFromJSONTyped, BulkUserCreateResponseFailedToJSON };
