import { exists } from '../runtime.js';
import { CustomHostnameStatusEnumFromJSON, CustomHostnameStatusEnumToJSON } from './CustomHostnameStatusEnum.js';
import { CustomHostnameUsageEnumFromJSON, CustomHostnameUsageEnumToJSON } from './CustomHostnameUsageEnum.js';
import { CustomHostnameVerificationRecordFromJSON, CustomHostnameVerificationRecordToJSON } from './CustomHostnameVerificationRecord.js';

/* tslint:disable */
function CustomHostnameFromJSON(json) {
    return CustomHostnameFromJSONTyped(json);
}
function CustomHostnameFromJSONTyped(json, ignoreDiscriminator) {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        'id': json['id'],
        'hostname': json['hostname'],
        'usage': CustomHostnameUsageEnumFromJSON(json['usage']),
        'status': CustomHostnameStatusEnumFromJSON(json['status']),
        'verificationRecords': (json['verificationRecords'].map(CustomHostnameVerificationRecordFromJSON)),
        'errors': !exists(json, 'errors') ? undefined : json['errors'],
    };
}
function CustomHostnameToJSON(value) {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        'id': value.id,
        'hostname': value.hostname,
        'usage': CustomHostnameUsageEnumToJSON(value.usage),
        'status': CustomHostnameStatusEnumToJSON(value.status),
        'verificationRecords': (value.verificationRecords.map(CustomHostnameVerificationRecordToJSON)),
        'errors': value.errors,
    };
}

export { CustomHostnameFromJSON, CustomHostnameFromJSONTyped, CustomHostnameToJSON };
