import { exists } from '../runtime.js';
import { CreateUserOauthRequestFromJSON, CreateUserOauthRequestToJSON } from './CreateUserOauthRequest.js';
import { CreateWalletRequestFromJSON, CreateWalletRequestToJSON } from './CreateWalletRequest.js';

/* tslint:disable */
function InternalBulkUpdateUserFieldsAllOfFromJSON(json) {
    return InternalBulkUpdateUserFieldsAllOfFromJSONTyped(json);
}
function InternalBulkUpdateUserFieldsAllOfFromJSONTyped(json, ignoreDiscriminator) {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        'id': !exists(json, 'id') ? undefined : json['id'],
        'emailVerifiedAt': !exists(json, 'emailVerifiedAt') ? undefined : (new Date(json['emailVerifiedAt'])),
        'email': !exists(json, 'email') ? undefined : json['email'],
        'wallets': !exists(json, 'wallets') ? undefined : (json['wallets'].map(CreateWalletRequestFromJSON)),
        'oauthAccounts': !exists(json, 'oauthAccounts') ? undefined : (json['oauthAccounts'].map(CreateUserOauthRequestFromJSON)),
    };
}
function InternalBulkUpdateUserFieldsAllOfToJSON(value) {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        'id': value.id,
        'emailVerifiedAt': value.emailVerifiedAt === undefined ? undefined : (value.emailVerifiedAt.toISOString()),
        'email': value.email,
        'wallets': value.wallets === undefined ? undefined : (value.wallets.map(CreateWalletRequestToJSON)),
        'oauthAccounts': value.oauthAccounts === undefined ? undefined : (value.oauthAccounts.map(CreateUserOauthRequestToJSON)),
    };
}

export { InternalBulkUpdateUserFieldsAllOfFromJSON, InternalBulkUpdateUserFieldsAllOfFromJSONTyped, InternalBulkUpdateUserFieldsAllOfToJSON };
