import { exists } from '../runtime.js';
import { EcdsaValidatorOptionsFromJSON, EcdsaValidatorOptionsToJSON } from './EcdsaValidatorOptions.js';
import { ProviderCreateRequestMultichainAccountAbstractionProvidersFromJSON, ProviderCreateRequestMultichainAccountAbstractionProvidersToJSON } from './ProviderCreateRequestMultichainAccountAbstractionProviders.js';
import { ProviderEntryPointVersionEnumFromJSON, ProviderEntryPointVersionEnumToJSON } from './ProviderEntryPointVersionEnum.js';
import { ProviderKernelVersionEnumFromJSON, ProviderKernelVersionEnumToJSON } from './ProviderKernelVersionEnum.js';
import { SmsCountryCodeFromJSON, SmsCountryCodeToJSON } from './SmsCountryCode.js';
import { ZerodevBundlerProviderFromJSON, ZerodevBundlerProviderToJSON } from './ZerodevBundlerProvider.js';

/* tslint:disable */
function ProviderUpdateRequestFromJSON(json) {
    return ProviderUpdateRequestFromJSONTyped(json);
}
function ProviderUpdateRequestFromJSONTyped(json, ignoreDiscriminator) {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        'clientId': !exists(json, 'clientId') ? undefined : json['clientId'],
        'clientSecret': !exists(json, 'clientSecret') ? undefined : json['clientSecret'],
        'providerProjectId': !exists(json, 'providerProjectId') ? undefined : json['providerProjectId'],
        'defaultChainId': !exists(json, 'defaultChainId') ? undefined : json['defaultChainId'],
        'defaultChain': !exists(json, 'defaultChain') ? undefined : json['defaultChain'],
        'keyExportUrl': !exists(json, 'keyExportUrl') ? undefined : json['keyExportUrl'],
        'useDynamicCredentials': !exists(json, 'useDynamicCredentials') ? undefined : json['useDynamicCredentials'],
        'scopes': !exists(json, 'scopes') ? undefined : json['scopes'],
        'appleKeyId': !exists(json, 'appleKeyId') ? undefined : json['appleKeyId'],
        'appleTeamId': !exists(json, 'appleTeamId') ? undefined : json['appleTeamId'],
        'shopifyStore': !exists(json, 'shopifyStore') ? undefined : json['shopifyStore'],
        'accountSid': !exists(json, 'accountSid') ? undefined : json['accountSid'],
        'twilioNumber': !exists(json, 'twilioNumber') ? undefined : json['twilioNumber'],
        'enabledCountries': !exists(json, 'enabledCountries') ? undefined : (json['enabledCountries'].map(SmsCountryCodeFromJSON)),
        'multichainAccountAbstractionProviders': !exists(json, 'multichainAccountAbstractionProviders') ? undefined : (json['multichainAccountAbstractionProviders'].map(ProviderCreateRequestMultichainAccountAbstractionProvidersFromJSON)),
        'entryPointVersion': !exists(json, 'entryPointVersion') ? undefined : ProviderEntryPointVersionEnumFromJSON(json['entryPointVersion']),
        'kernelVersion': !exists(json, 'kernelVersion') ? undefined : ProviderKernelVersionEnumFromJSON(json['kernelVersion']),
        'ecdsaProviderType': !exists(json, 'ecdsaProviderType') ? undefined : EcdsaValidatorOptionsFromJSON(json['ecdsaProviderType']),
        'enableKernelV3Migration': !exists(json, 'enableKernelV3Migration') ? undefined : json['enableKernelV3Migration'],
        'enableEIP7702': !exists(json, 'enableEIP7702') ? undefined : json['enableEIP7702'],
        'factoryAddress': !exists(json, 'factoryAddress') ? undefined : json['factoryAddress'],
        'paymasterAddress': !exists(json, 'paymasterAddress') ? undefined : json['paymasterAddress'],
        'passkeyAddress': !exists(json, 'passkeyAddress') ? undefined : json['passkeyAddress'],
        'sessionAddress': !exists(json, 'sessionAddress') ? undefined : json['sessionAddress'],
        'zerodevBundlerProvider': !exists(json, 'zerodevBundlerProvider') ? undefined : ZerodevBundlerProviderFromJSON(json['zerodevBundlerProvider']),
        'zerodevBundlerRpcUrl': !exists(json, 'zerodevBundlerRpcUrl') ? undefined : json['zerodevBundlerRpcUrl'],
        'zerodevPaymasterRpcUrl': !exists(json, 'zerodevPaymasterRpcUrl') ? undefined : json['zerodevPaymasterRpcUrl'],
        'zerodevKernelDelegationAddress': !exists(json, 'zerodevKernelDelegationAddress') ? undefined : json['zerodevKernelDelegationAddress'],
    };
}
function ProviderUpdateRequestToJSON(value) {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        'clientId': value.clientId,
        'clientSecret': value.clientSecret,
        'providerProjectId': value.providerProjectId,
        'defaultChainId': value.defaultChainId,
        'defaultChain': value.defaultChain,
        'keyExportUrl': value.keyExportUrl,
        'useDynamicCredentials': value.useDynamicCredentials,
        'scopes': value.scopes,
        'appleKeyId': value.appleKeyId,
        'appleTeamId': value.appleTeamId,
        'shopifyStore': value.shopifyStore,
        'accountSid': value.accountSid,
        'twilioNumber': value.twilioNumber,
        'enabledCountries': value.enabledCountries === undefined ? undefined : (value.enabledCountries.map(SmsCountryCodeToJSON)),
        'multichainAccountAbstractionProviders': value.multichainAccountAbstractionProviders === undefined ? undefined : (value.multichainAccountAbstractionProviders.map(ProviderCreateRequestMultichainAccountAbstractionProvidersToJSON)),
        'entryPointVersion': ProviderEntryPointVersionEnumToJSON(value.entryPointVersion),
        'kernelVersion': ProviderKernelVersionEnumToJSON(value.kernelVersion),
        'ecdsaProviderType': EcdsaValidatorOptionsToJSON(value.ecdsaProviderType),
        'enableKernelV3Migration': value.enableKernelV3Migration,
        'enableEIP7702': value.enableEIP7702,
        'factoryAddress': value.factoryAddress,
        'paymasterAddress': value.paymasterAddress,
        'passkeyAddress': value.passkeyAddress,
        'sessionAddress': value.sessionAddress,
        'zerodevBundlerProvider': ZerodevBundlerProviderToJSON(value.zerodevBundlerProvider),
        'zerodevBundlerRpcUrl': value.zerodevBundlerRpcUrl,
        'zerodevPaymasterRpcUrl': value.zerodevPaymasterRpcUrl,
        'zerodevKernelDelegationAddress': value.zerodevKernelDelegationAddress,
    };
}

export { ProviderUpdateRequestFromJSON, ProviderUpdateRequestFromJSONTyped, ProviderUpdateRequestToJSON };
